Create prepare_env.py from prepare_env.sh and config_functest.py
authorjose.lausuch <jose.lausuch@ericsson.com>
Mon, 25 Apr 2016 16:08:22 +0000 (18:08 +0200)
committerjose.lausuch <jose.lausuch@ericsson.com>
Wed, 27 Apr 2016 13:34:56 +0000 (15:34 +0200)
JIRA: FUNCTEST-227

Change-Id: I1aa890b9f91ec524c766ba3c460666ed227f2126
Signed-off-by: jose.lausuch <jose.lausuch@ericsson.com>
ci/__init__.py [moved from CI/__init__.py with 100% similarity]
ci/check_os.sh [new file with mode: 0755]
ci/prepare_env.py [new file with mode: 0644]
ci/testcases.yaml [moved from CI/testcases.yaml with 100% similarity]
ci/tier_builder.py [moved from CI/tier_builder.py with 100% similarity]
ci/tier_handler.py [moved from CI/tier_handler.py with 100% similarity]
testcases/VIM/OpenStack/CI/libraries/check_os.sh
utils/clean_openstack.py [moved from testcases/VIM/OpenStack/CI/libraries/clean_openstack.py with 100% similarity]
utils/functest_logger.py
utils/generate_defaults.py [moved from testcases/VIM/OpenStack/CI/libraries/generate_defaults.py with 90% similarity]
utils/openstack_utils.py

similarity index 100%
rename from CI/__init__.py
rename to ci/__init__.py
diff --git a/ci/check_os.sh b/ci/check_os.sh
new file mode 100755 (executable)
index 0000000..bb13353
--- /dev/null
@@ -0,0 +1,90 @@
+#!/bin/bash
+#
+# Simple script to check the basic OpenStack clients
+#
+# Author:
+#    jose.lausuch@ericsson.com
+#
+
+verify_connectivity() {
+    for i in $(seq 0 9); do
+        if echo "test" | nc -v -w 10 $1 $2 &>/dev/null; then
+            return 0
+        fi
+        sleep 1
+    done
+    return 1
+}
+
+
+if [ -z $OS_AUTH_URL ];then
+    echo "ERROR: OS_AUTH_URL environment variable missing... Have you sourced the OpenStack credentials?"
+    exit 1
+fi
+
+
+echo "Checking OpenStack endpoints:"
+publicURL=$OS_AUTH_URL
+publicIP=$(echo $publicURL|sed 's/^.*http\:\/\///'|sed 's/.[^:]*$//')
+publicPort=$(echo $publicURL|sed 's/^.*://'|sed 's/.[^\/]*$//')
+echo ">>Verifying connectivity to the public endpoint $publicIP:$publicPort..."
+verify_connectivity $publicIP $publicPort
+RETVAL=$?
+if [ $RETVAL -ne 0 ]; then
+    echo "ERROR: Cannot talk to the public endpoint $publicIP:$publicPort ."
+    echo "OS_AUTH_URL=$OS_AUTH_URL"
+    exit 1
+fi
+echo "  ...OK"
+
+adminURL=$(openstack catalog show  identity |grep adminURL|awk '{print $4}')
+adminIP=$(echo $adminURL|sed 's/^.*http\:\/\///'|sed 's/.[^:]*$//')
+adminPort=$(echo $adminURL|sed 's/^.*://'|sed 's/.[^\/]*$//')
+echo ">>Verifying connectivity to the admin endpoint $adminIP:$adminPort..."
+verify_connectivity $adminIP $adminPort
+RETVAL=$?
+if [ $RETVAL -ne 0 ]; then
+    echo "ERROR: Cannot talk to the admin endpoint $adminIP:$adminPort ."
+    echo "$adminURL"
+    exit 1
+fi
+echo "  ...OK"
+
+
+echo "Checking OpenStack basic services:"
+commands=('openstack endpoint list' 'nova list' 'neutron net-list' \
+            'glance image-list' 'cinder list')
+for cmd in "${commands[@]}"
+do
+    service=$(echo $cmd | awk '{print $1}')
+    echo ">>Checking $service service..."
+    $cmd &>/dev/null
+    result=$?
+    if [ $result -ne 0 ];
+    then
+        echo "ERROR: Failed execution $cmd. The $service does not seem to be working."
+        exit 1
+    else
+        echo "  ...OK"
+    fi
+done
+
+echo "OpenStack services are OK."
+
+echo "Checking External network..."
+networks=($(neutron net-list | tail -n +4 | head -n -1 | awk '{print $2}'))
+is_external=False
+for net in "${networks[@]}"
+do
+    is_external=$(neutron net-show $net|grep "router:external"|awk '{print $4}')
+    if [ $is_external == "True" ]; then
+        echo "External network found: $net"
+        break
+    fi
+done
+if [ $is_external == "False" ]; then
+    echo "ERROR: There are no external networks in the deployment."
+    exit 1
+fi
+
+exit 0
diff --git a/ci/prepare_env.py b/ci/prepare_env.py
new file mode 100644 (file)
index 0000000..710a767
--- /dev/null
@@ -0,0 +1,301 @@
+#!/bin/bash
+#
+# Author: Jose Lausuch (jose.lausuch@ericsson.com)
+#
+# Installs the Functest framework within the Docker container
+# and run the tests automatically
+#
+#
+# All rights reserved. This program and the accompanying materials
+# are made available under the terms of the Apache License, Version 2.0
+# which accompanies this distribution, and is available at
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+
+import argparse
+import os
+import re
+import subprocess
+import sys
+import yaml
+
+import functest.ci.tier_builder as tb
+import functest.utils.functest_logger as ft_logger
+import functest.utils.functest_utils as ft_utils
+import functest.utils.generate_defaults as gen_def
+import functest.utils.openstack_utils as os_utils
+
+
+""" arguments """
+actions = ['start', 'check']
+parser = argparse.ArgumentParser()
+parser.add_argument("action", help="Possible actions are: "
+                    "'{d[0]}|{d[1]}' ".format(d=actions))
+parser.add_argument("-d", "--debug", help="Debug mode", action="store_true")
+args = parser.parse_args()
+
+
+""" logging configuration """
+logger = ft_logger.Logger("prepare_env").getLogger()
+
+
+""" global variables """
+INSTALLERS = ['fuel', 'compass', 'apex', 'joid']
+CI_INSTALLER_TYPE = ""
+CI_INSTALLER_IP = ""
+CI_SCENARIO = ""
+CI_DEBUG = False
+REPOS_DIR = os.getenv('repos_dir')
+FUNCTEST_REPO = REPOS_DIR + '/functest/'
+
+with open("/home/opnfv/repos/functest/testcases/config_functest.yaml") as f:
+    functest_yaml = yaml.safe_load(f)
+
+FUNCTEST_CONF_DIR = functest_yaml.get("general").get(
+    "directories").get("dir_functest_conf")
+
+FUNCTEST_DATA_DIR = functest_yaml.get("general").get(
+    "directories").get("dir_functest_data")
+FUNCTEST_RESULTS_DIR = functest_yaml.get("general").get(
+    "directories").get("dir_results")
+DEPLOYMENT_MAME = functest_yaml.get("rally").get("deployment_name")
+TEMPEST_REPO_DIR = functest_yaml.get("general").get(
+    "directories").get("dir_repo_tempest")
+
+ENV_FILE = FUNCTEST_CONF_DIR + "/env_active"
+
+
+def print_separator():
+    logger.info("==============================================")
+
+
+def check_env_variables():
+    print_separator()
+    logger.info("Checking environment variables...")
+    global CI_INSTALLER_TYPE
+    global CI_INSTALLER_IP
+    global CI_DEBUG
+    global CI_SCENARIO
+    CI_INSTALLER_TYPE = os.getenv('INSTALLER_TYPE')
+    CI_INSTALLER_IP = os.getenv('INSTALLER_IP')
+    CI_SCENARIO = os.getenv('DEPLOY_SCENARIO')
+    CI_NODE = os.getenv('NODE_NAME')
+    CI_BUILD_TAG = os.getenv('BUILD_TAG')
+    CI_DEBUG = os.getenv('CI_DEBUG')
+
+    if CI_INSTALLER_TYPE is None:
+        logger.warning("The env variable 'INSTALLER_TYPE' is not defined.")
+        CI_INSTALLER_TYPE = "undefined"
+    else:
+        if os.getenv('INSTALLER_TYPE') not in INSTALLERS:
+            logger.warning("INSTALLER_TYPE=%s is not a valid OPNFV installer. "
+                           "Available OPNFV Installers are : %s."
+                           "Setting INSTALLER_TYPE=undefined." % INSTALLERS)
+            CI_INSTALLER_TYPE = "undefined"
+        else:
+            logger.info("    INSTALLER_TYPE=%s" % CI_INSTALLER_TYPE)
+
+    if CI_INSTALLER_IP is None:
+        logger.warning("The env variable 'INSTALLER_IP' is not defined. "
+                       "It is needed to fetch the OpenStack credentials. "
+                       "If the credentials are not provided to the "
+                       "container as a volume, please add this env variable "
+                       "to the 'docker run' command.")
+    else:
+        logger.info("    INSTALLER_IP=%s" % CI_INSTALLER_IP)
+
+    if CI_SCENARIO is None:
+        logger.warning("The env variable 'DEPLOY_SCENARIO' is not defined. "
+                       "Setting CE_SCENARIO=undefined.")
+        CI_SCENARIO = "undefined"
+    else:
+        logger.info("    DEPLOY_SCENARIO=%s" % CI_SCENARIO)
+    if CI_DEBUG:
+        logger.info("    CI_DEBUG=%s" % CI_DEBUG)
+
+    if CI_NODE:
+        logger.info("    NODE_NAME=%s" % CI_NODE)
+
+    if CI_BUILD_TAG:
+        logger.info("    BUILD_TAG=%s" % CI_BUILD_TAG)
+
+
+def create_directories():
+    print_separator()
+    logger.info("Creating needed directories...")
+    if not os.path.exists(FUNCTEST_CONF_DIR):
+        os.makedirs(FUNCTEST_CONF_DIR)
+        logger.info("    %s created." % FUNCTEST_CONF_DIR)
+    else:
+        logger.debug("   %s already exists." % FUNCTEST_CONF_DIR)
+
+    if not os.path.exists(FUNCTEST_DATA_DIR):
+        os.makedirs(FUNCTEST_DATA_DIR)
+        logger.info("    %s created." % FUNCTEST_DATA_DIR)
+    else:
+        logger.debug("   %s already exists." % FUNCTEST_DATA_DIR)
+
+    ODL_RESULTS_DIR = FUNCTEST_RESULTS_DIR + "/ODL/"
+    if not os.path.exists(ODL_RESULTS_DIR):
+        os.makedirs(ODL_RESULTS_DIR)
+        logger.info("    %s created." % ODL_RESULTS_DIR)
+    else:
+        logger.debug("   %s already exists." % ODL_RESULTS_DIR)
+
+
+def source_rc_file():
+    print_separator()
+    logger.info("Fetching RC file...")
+    rc_file = os.getenv('creds')
+    if rc_file is None:
+        logger.warning("The environment variable 'creds' must be set and"
+                       "pointing to the local RC file. Using default: "
+                       "/home/opnfv/functest/conf/openstack.creds ...")
+        rc_file = "/home/opnfv/functest/conf/openstack.creds ..."
+
+    if not os.path.isfile(rc_file):
+        logger.info("RC file not provided. "
+                    "Fetching it from the installer...")
+        if CI_INSTALLER_IP is None:
+            logger.error("The env variable CI_INSTALLER_IP must be provided in"
+                         " order to fetch the credentials from the installer.")
+            sys.exit("Missing CI_INSTALLER_IP.")
+        if CI_INSTALLER_TYPE not in INSTALLERS:
+            logger.error("Cannot fetch credentials. INSTALLER_TYPE=%s is "
+                         "not a valid OPNFV installer. Available "
+                         "installers are : %s." % INSTALLERS)
+            sys.exit("Wrong INSTALLER_TYPE.")
+
+        cmd = ("/home/opnfv/repos/releng/utils/fetch_os_creds.sh "
+               "-d %s -i %s -a %s"
+               % (rc_file, CI_INSTALLER_TYPE, CI_INSTALLER_IP))
+        logger.debug("Executing command: %s" % cmd)
+        p = subprocess.Popen(cmd.split(), stdout=subprocess.PIPE)
+        output = p.communicate()[0]
+        logger.debug(output)
+        if p.returncode != 0:
+            logger.error("Failed to fetch credentials from installer.")
+            sys.exit(1)
+    else:
+        logger.info("RC file provided in %s." % rc_file)
+        if os.path.getsize(rc_file) == 0:
+            logger.error("The file %s is empty." % rc_file)
+            sys.exit(1)
+
+    logger.info("Sourcing the OpenStack RC file...")
+    creds = os_utils.source_credentials(rc_file)
+    str = ""
+    for key, value in creds.iteritems():
+        if re.search("OS_", key):
+            str += "\n\t\t\t\t\t\t   " + key + "=" + value
+    logger.debug("Used credentials: %s" % str)
+
+
+def verify_deployment():
+    print_separator()
+    logger.info("Verifying OpenStack services...")
+    cmd = ("%s/ci/check_os.sh" % FUNCTEST_REPO)
+
+    logger.debug("Executing command: %s" % cmd)
+    p = subprocess.Popen(cmd, stdout=subprocess.PIPE, shell=True)
+
+    while p.poll() is None:
+        line = p.stdout.readline().rstrip()
+        if "ERROR" in line:
+            logger.error(line)
+            sys.exit("Problem while running 'check_os.sh'.")
+        logger.debug(line)
+
+
+def install_rally():
+    print_separator()
+    logger.info("Creating Rally environment...")
+
+    cmd = "rally deployment destroy opnfv-rally"
+    ft_utils.execute_command(cmd, logger=None, exit_on_error=False)
+
+    cmd = "rally deployment create --fromenv --name=" + DEPLOYMENT_MAME
+    if not ft_utils.execute_command(cmd, logger):
+        logger.error("Problem while creating Rally deployment.")
+        sys.exit(cmd)
+
+    logger.info("Installing tempest from existing repo...")
+    cmd = ("rally verify install --source " + TEMPEST_REPO_DIR +
+           " --system-wide")
+    if not ft_utils.execute_command(cmd, logger):
+        logger.error("Problem while installing Tempest.")
+        sys.exit(cmd)
+
+    cmd = "rally deployment check"
+    if not ft_utils.execute_command(cmd, logger):
+        logger.error("OpenStack not responding or faulty Rally deployment.")
+        sys.exit(cmd)
+
+    cmd = "rally show images"
+    if not ft_utils.execute_command(cmd, logger):
+        logger.error("Problem while listing OpenStack images.")
+        sys.exit(cmd)
+
+    cmd = "rally show flavors"
+    if not ft_utils.execute_command(cmd, logger):
+        logger.error("Problem while showing OpenStack flavors.")
+        sys.exit(cmd)
+
+
+def generate_os_defaults():
+    print_separator()
+    logger.info("Generating OpenStack defaults...")
+    gen_def.main()
+
+
+def generate_tiers():
+    print_separator()
+    logger.info("Generating Tiers and test cases...")
+    file = FUNCTEST_REPO + "/ci/testcases.yaml"
+
+    t = tb.TierBuilder(CI_INSTALLER_TYPE, CI_SCENARIO, file)
+    logger.info("Tiers and tests to be executed:\n\n%s" % t)
+
+
+def check_environment():
+    msg_not_active = "The Functest environment is not installed."
+    if not os.path.isfile(ENV_FILE):
+        logger.error(msg_not_active)
+        sys.exit(1)
+
+    with open(ENV_FILE, "r") as env_file:
+        s = env_file.read()
+        if not re.search("1", s):
+            logger.error(msg_not_active)
+            sys.exit(1)
+
+    logger.info("Functest environment installed.")
+
+
+def main():
+    if not (args.action in actions):
+        logger.error('Argument not valid.')
+        sys.exit()
+
+    if args.action == "start":
+        print ("\n######### Preparing Functest environment #########\n")
+        check_env_variables()
+        create_directories()
+        source_rc_file()
+        verify_deployment()
+        install_rally()
+        generate_os_defaults()
+        generate_tiers()
+
+        with open(ENV_FILE, "w") as env_file:
+            env_file.write("1")
+
+        check_environment()
+
+    if args.action == "check":
+        check_environment()
+
+    exit(0)
+
+if __name__ == '__main__':
+    main()
similarity index 100%
rename from CI/testcases.yaml
rename to ci/testcases.yaml
similarity index 100%
rename from CI/tier_builder.py
rename to ci/tier_builder.py
similarity index 100%
rename from CI/tier_handler.py
rename to ci/tier_handler.py
index 98b8605..c247d5a 100755 (executable)
@@ -7,8 +7,8 @@
 #
 
 verify_connectivity() {
-    for i in $(seq 0 10); do
-        if echo "test" | nc -v $1 $2 &>/dev/null; then
+    for i in $(seq 0 9); do
+        if echo "test" | nc -v -w 10 $1 $2 &>/dev/null; then
             return 0
         fi
         sleep 1
@@ -88,27 +88,4 @@ if [ $is_external == "False" ]; then
     exit 1
 fi
 
-
-# Temporary output information
-# To see the initial OpenStack defaults
-# in case we delete something later on.
-# This is to be removed for the release
-if [[ "${CI_DEBUG,,}" == "true" ]];then
-    echo "nova list:"
-    nova list
-    echo "cinder list"
-    cinder list
-    echo "nova floating-ip-list:"
-    nova floating-ip-list
-    echo "neutron net-list:"
-    neutron net-list
-    echo "neutron router-list:"
-    neutron router-list
-    echo "neutron security-group-list:"
-    neutron security-group-list
-    echo "openstack project list:"
-    openstack project list
-    echo "openstack user list:"
-    openstack user list
-fi
 exit 0
index 5639ed8..b9b3087 100644 (file)
@@ -38,10 +38,10 @@ class Logger:
 
         CI_DEBUG = os.getenv('CI_DEBUG')
 
-        if CI_DEBUG.lower() == "true":
+        ch.setLevel(logging.INFO)
+
+        if CI_DEBUG is not None and CI_DEBUG.lower() == "true":
             ch.setLevel(logging.DEBUG)
-        else:
-            ch.setLevel(logging.INFO)
 
         self.logger.addHandler(ch)
 
similarity index 90%
rename from testcases/VIM/OpenStack/CI/libraries/generate_defaults.py
rename to utils/generate_defaults.py
index 5e799e4..4c2065e 100644 (file)
@@ -20,8 +20,6 @@
 # http://www.apache.org/licenses/LICENSE-2.0
 #
 
-import argparse
-import logging
 import os
 import yaml
 
@@ -30,27 +28,11 @@ from neutronclient.v2_0 import client as neutronclient
 from keystoneclient.v2_0 import client as keystoneclient
 from cinderclient import client as cinderclient
 
-import openstack_utils
-
-parser = argparse.ArgumentParser()
-parser.add_argument("-d", "--debug", help="Debug mode", action="store_true")
-args = parser.parse_args()
-
+import functest.utils.openstack_utils as openstack_utils
+import functest.utils.functest_logger as ft_logger
 
 """ logging configuration """
-logger = logging.getLogger('generate_defaults')
-logger.setLevel(logging.DEBUG)
-
-ch = logging.StreamHandler()
-if args.debug:
-    ch.setLevel(logging.DEBUG)
-else:
-    ch.setLevel(logging.INFO)
-
-formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - ' +
-                              '%(message)s')
-ch.setFormatter(formatter)
-logger.addHandler(ch)
+logger = ft_logger.Logger("generate_defaults").getLogger()
 
 REPO_PATH = os.environ['repos_dir'] + '/functest/'
 if not os.path.exists(REPO_PATH):
@@ -193,13 +175,11 @@ def main():
     with open(DEFAULTS_FILE, 'w+') as yaml_file:
         yaml_file.write(yaml.safe_dump(defaults, default_flow_style=False))
         yaml_file.seek(0)
-        logger.info("Openstack Defaults found in the deployment:")
+        logger.debug("Openstack Defaults found in the deployment:")
         print yaml_file.read()
         logger.debug("NOTE: These objects will NOT be deleted after " +
                      "running the tests.")
 
-    exit(0)
-
 
 if __name__ == '__main__':
     main()
index ff3968d..2ae2842 100644 (file)
@@ -10,6 +10,7 @@
 
 import os
 import os.path
+import subprocess
 import sys
 
 # ----------------------------------------------------------
@@ -73,6 +74,15 @@ def get_credentials(service):
     return creds
 
 
+def source_credentials(rc_file):
+    pipe = subprocess.Popen(". %s; env" % rc_file, stdout=subprocess.PIPE,
+                            shell=True)
+    output = pipe.communicate()[0]
+    env = dict((line.split("=", 1) for line in output.splitlines()))
+    os.environ.update(env)
+    return env
+
+
 # *********************************************
 #   NOVA
 # *********************************************